package org.once.serviceChoicer.candidate;

import java.util.List;

import org.once.serviceChoicer.input.qos.IQoSAttr.Type;


public interface ICandidate {

	public List<IRule> getRules(Type type);	
	public List<IRule> getAllRules();
	public String getName();
	public String getType();
	public String getServiceID();
	public String getWsdlAddr();
	public String toString();
	boolean equals(Object obj);
	public int hashCode();
	
	public ICandidate clone();
}
