package org.once.serviceChoicer.input.process.impl;

import java.util.ArrayList;
import java.util.List;

import org.once.serviceChoicer.input.process.IService;
import org.once.serviceChoicer.input.process.ISubPath;

public class SubPath implements ISubPath{
	
	private List<IService> list;
	
	public SubPath(List<IService> services){
		this.list = services;
	}
	public SubPath(){
		this.list=new ArrayList<IService>();
	}

	public void addService(IService service){
		list.add(service);
	}
	public void addList(List<IService> sList){
		list.addAll(sList);
	}
	public List<IService> getServices() {
		return this.list;
	}
	

}
