package org.once.serviceChoicer.math.impl;

import java.util.ArrayList;
import java.util.List;

import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.math.IVariable;

public class Polynomial implements IPolynomial{	// ʽ
	
	private ArrayList<Monomial> list;		// ʽɺܶ൥ʽ
	
	public Polynomial(){
		list = new ArrayList<Monomial>();
	}
	
	public Polynomial(double d){
		list = new ArrayList<Monomial>();
		list.add(new Monomial(d));
	}
	
	public Polynomial(IVariable v){
		list = new ArrayList<Monomial>();
		list.add(new Monomial(v));
	}

	public IPolynomial clone(){
		Polynomial obj = null;
		try {
			obj = (Polynomial)super.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		obj.list = new ArrayList<Monomial>();
		for(int i = 0; i < list.size(); i++){
			obj.list.add((Monomial) list.get(i).clone());
		}
		return obj;	
	}
	
	public IPolynomial multi(IPolynomial p) {
		Polynomial temp = (Polynomial) p;
		Polynomial temp2 = (Polynomial) this.clone();
		Polynomial result = new Polynomial();
		for(int i = 0; i < temp.list.size(); i++){	
			result.add(((Polynomial)temp2.clone()).multi(temp.list.get(i)));
		}
		this.list = result.list;
		return this;
	}
	
	private IPolynomial multi(Monomial m){
			for(int i = 0; i < this.list.size(); i++){
				this.list.get(i).multi(m);
			}
		return this;
	}
	

	public IPolynomial multiCoef(double c) {
		for(int i = 0; i < this.list.size(); i++){
			list.get(i).multiCoef(c);
		}
		return this;
	}

	public IPolynomial unit(){
		// ϲͬ
		ArrayList<Monomial> newList = new ArrayList<Monomial>();
		int i, j;
		for(i = 0; i < list.size(); i++){
			for(j = 0; j < newList.size(); j++){
				if(list.get(i).canUnit(newList.get(j))){
					newList.get(j).add(list.get(i));
					break;
				}
			}
			if(j == newList.size()){
				newList.add(list.get(i));
			}
		}
		this.list = newList;
		return this;
	}
	
	public IPolynomial add(IPolynomial p) {
		this.list.addAll(((Polynomial)p).list);
		return this;
	}
	public String toString(){
		String result = new String();
		for(int i = 0; i < this.list.size(); i++){
			result += list.get(i).toString();
		}
		return result;
	}

	@Override
	public boolean isEmpty() {
		if(this == null || this.list == null)
			return true;
		else{
			for(int i = 0; i < this.list.size(); i++){
				if (!list.get(i).isEmpty())
					return false;
			}
			return true;
		}
	}
	
	@Override
	public List<Monomial> getMList() {
		return this.list;
	}

	@Override
	public int uk() {
		return this.list.size();
	}
	
	public Monomial get(int i){
		if(i < list.size())
			return this.list.get(i);
		return null;
	}
	
/*	public static void main(String[] args){
		IPolynomial pn1 = new Polynomial(new Variable("A"));
		IPolynomial pn2 = new Polynomial(new Variable("B"));
		IPolynomial pn = pn1.clone();
		pn.add(pn1.clone().multiCoef(-2));
		pn.add(new Polynomial(3));
		System.out.println(pn);
		IPolynomial r = pn2.multi(pn);
		System.out.println(r);
		r.unit();
		System.out.println(r);	
	}*/


}
