package org.once.serviceChoicer.output;

import org.once.serviceChoicer.math.IPolynomial;


public interface IConstrain {
	
	public enum OPType{
		EQUAL(0), GT(1), LT(2);
		
		private int value;
		
		private OPType(int value){
			this.value = value;
		}
		
		public String toString(){
			switch(this.value){
			case 0:
				return "=";
			case 1:
				return ">";
			case 2:
				return "<";
			default:
				return null;
			}
			
		}

		public OPType getOpposite() {
			switch (this.value){
			case 0:
				return EQUAL;
			case 1:
				return LT;
			case 2:
				return GT;
			default:
				return null;	
			}
		}
	}
	
	/**
	 *   ԼһΪʽұΪ0ĵʽ򲻵ʽ
	 */
	
	public IPolynomial getLeft();
	public OPType getOp();	
	public String toString();
}
