package org.once.serviceChoicer.output.impl;

import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.output.ITarget;


public class Target implements ITarget{
	
	
	private Type type;
	private IPolynomial expression;
	
	public Target(Type t, IPolynomial pn){
		this.type = t;
		this.expression = pn;
	}
	
	public String toString(){	
		String result =	this.type.toString() + "\t";
		result += this.expression.toString();
		return result;
	}
	
	public Type getType(){
		return this.type;
	}
	
	public IPolynomial getPolynomial(){
		return this.expression;
	}
}
