package org.once.serviceChoicer.qosDescrip2.token.impl;


import org.once.serviceChoicer.qosDescrip2.token.ILAttr4log;
import org.once.serviceChoicer.qosDescrip2.token.IToken4log;

public class Token4log implements IToken4log{ 
	
	private String value;
	private Type type;
	private ILAttr4log attr;
	
	public Token4log(String val){
		this.value = val.trim();
		this.type = type();
	}
	
	public Token4log(){
		this.value = null;
		this.type = Type.NON_FINAL;
	}
	
	public Token4log(Type type){
		this.type = type;
	}
	
	/*public Token4log(ILAttr4log attr2) {
		this.value = attr2.getLAttrValue().toString();
		this.type = Type.ID;
	}*/

	public Type getType(){
		return this.type;
	}
	
	private Type type(){
		if(this.value.equalsIgnoreCase("and")){
			return Type.AND;
		}
		if(this.value.equalsIgnoreCase("or")){
			return Type.OR;
		}
		if(this.value.equalsIgnoreCase("not")){
			return Type.NOT;
		}
		if(this.value.equalsIgnoreCase("$")){
			return Type.END;
		}
		if(this.value.equalsIgnoreCase("(")){
			return Type.L;
		}
		if(this.value.equalsIgnoreCase(")")){
			return Type.R;
		}
		return Type.ID;
	}
	
	public String toString(){
		return this.value + this.type;
	}
	
	public String getValue(){
		return this.value;
	}

	@Override
	public ILAttr4log getLAttrValue() {
		return this.attr;
	}

	@Override
	public void setLAttrValue(ILAttr4log obj) {
		this.attr = obj;
	}
}
