package org.once.serviceChoicer.input.process.impl;

import java.util.List;

import org.once.serviceChoicer.input.process.IEPath;
import org.once.serviceChoicer.input.process.IService;
import org.once.serviceChoicer.input.process.ISubPath;

public class EPath implements IEPath{

	private static int pathNo = 0;
	private List<IService> services;
	private List<ISubPath> subPathes;
	private double pro;
	private int num;
	
	public EPath(List<ISubPath> subPathes, List<IService> services, double p){
		pathNo++;
		this.services = services;
		this.subPathes = subPathes;
		this.pro = p;
		this.num = pathNo;
	}
	
	public int getPathNo() {
		return this.num;
	}

	public double getProbobility() {
		return this.pro;
	}

	public List<IService> getServices() {
		return services;
	}

	public List<ISubPath> getSubPathes() {
		return subPathes;
	}

	@Override
	public void setProperty(double p) {
		this.pro = p;
		
	}

}
