package org.once.serviceChoicer.output.impl;

import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.math.impl.Polynomial;
import org.once.serviceChoicer.output.IConstrain;


public class LinerConstrain implements IConstrain{
	
	private OPType type;
	private IPolynomial pn;
	
	public LinerConstrain(IPolynomial pn, OPType type, int right){
		this.pn = pn;
		this.type = type;
		if(right != 0){
			this.pn = pn.add(new Polynomial(right).multiCoef(-1));
		}
	}

	@Override
	public IPolynomial getLeft() {
		return this.pn;
	}

	@Override
	public OPType getOp() {
		return this.type;
	}
	
	public String toString(){
		String result = this.pn.toString();
		result += this.type.toString();
		result += " 0";
		return result;
	}


}
