package org.once.serviceChoicer.output.impl;

import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.math.IVariable;
import org.once.serviceChoicer.math.impl.Polynomial;
import org.once.serviceChoicer.output.IConstrain;


public class QoSConstrain implements IConstrain{
	
	private OPType type;
	private IPolynomial pn;
	
	public QoSConstrain(){
	}
	
	public QoSConstrain(IVariable var, OPType type, IPolynomial pn){
		this.type = type.getOpposite();
		this.pn = pn;
		this.pn.add(new Polynomial(var).multiCoef(-1));
	}
	
	public IPolynomial getLeft(){
		return pn;
	}
	
	public OPType getOp() {
		return this.type;
	}

	public String toString(){
		
		pn.unit();
		String result = pn.toString();
		result += type.toString();
		result += " 0";
		
		return result;
	}
	
}
