package org.once.serviceChoicer.qosDescrip2.parser.abstr;

import java.util.ArrayList;
import java.util.List;

import org.once.serviceChoicer.qosDescrip2.parser.ITokenParser;
import org.once.serviceChoicer.qosDescrip2.token.ILAttr4log;
import org.once.serviceChoicer.qosDescrip2.token.IToken;
import org.once.serviceChoicer.qosDescrip2.token.impl.Token4log;


public abstract class ATokenParser4log implements ITokenParser{
//	private List<ICandidate> candidates;
	private List<IToken> tokenList;
	
/*	public ATokenParser4log(List<ICandidate> candidates){
		this.candidates = candidates;
	}*/
	
	public ATokenParser4log(){
	}
	
	public 	abstract ILAttr4log parse(String str);
	protected abstract List<IToken> parserID(List<IToken> tokenList);

	public List<IToken> cutToken(String rule) {
		// ǰӿո,ַǰӿո
		rule = rule.toLowerCase();
		rule = rule.replace("(", " ( ");
		rule = rule.replace(")", " ) ");
		rule = " " + rule + " ";
		String[] p = {" and ", " or ", " not ", " ( ", " ) "}; 	//  and, or, not, (, ) Ϊָָ
		tokenList = new ArrayList<IToken>();
		while(!rule.isEmpty()){
			int[] result = indexOf(rule,p);
			int index = result[0];
			if(index == -1){
				tokenList.add(new Token4log(rule));
				break;
			}
			String tokenStr = rule.substring(0,index);
			tokenList.add(new Token4log(tokenStr));
			rule = rule.substring(index,rule.length()); 
			tokenList.add(new Token4log(rule.substring(0,result[1])));
			rule = rule.substring(result[1],rule.length());
		}
		tokenList = parserID(tokenList);
		return tokenList;
		
/*	//  A:a = B:bת A:a = value
		List<IToken> newList = new ArrayList<IToken>();
		for(int i = 0; i < tokenList.size(); i++){
			IToken token = tokenList.get(i);
			if(token.getType() == Type.ID){
				QoSDescripTest qosDes = new QoSDescripTest(token.getValue());
				if(qosDes.getVal().contains(":")){
					// ֵ
					ArrayList<String> strList = getCandidateVal(qosDes.getCType(),qosDes.getCAttr());
					if(strList == null || strList.size() == 0)
						continue;
					newList.add(new Token4log(Type.L));
					newList.addAll(getTokens(qosDes.getLeftPart(),qosDes.getVal(),strList));
					newList.add(new Token4log(Type.R));
				}else
					newList.add(token);
			}else{
				newList.add(token);
			}
		}
		return newList;*/
	}
/*	
	private ArrayList<IToken4log> getTokens(String leftPart, String val,
			ArrayList<String> strList) 
	{
		ArrayList<IToken4log> result = new ArrayList<IToken4log>();
		
		result.add(new Token4log(leftPart + "=" + strList.get(0)));
		result.add(new Token4log(Type.AND));
		result.add(new Token4log(val+ "=" + strList.get(0)));
		         
		for(int j = 1; j < strList.size(); j++){
			result.add(new Token4log(Type.OR));
			result.add(new Token4log(leftPart + "=" + strList.get(j)));
			result.add(new Token4log(Type.AND));
			result.add(new Token4log(val+ "=" + strList.get(j)));
		}

		return result;
	}

	private ArrayList<String> getCandidateVal(String type, String attr) {
		ArrayList<String> result = new ArrayList<String>();
		
		for(int index = 0; index < this.candidates.size(); index++){
			Candidate cand = (Candidate) this.candidates.get(index); 
			if(cand.getType().equalsIgnoreCase(type) &&
					cand.attrMap.containsKey(attr)){
				//  get the value of attr
				String val = cand.attrMap.get(attr);
				// add to the list
				int num = 0;
				for(num = 0; num < result.size(); num++){
					if(result.get(num).equalsIgnoreCase(val)){
						break;
					}
				}
				if(num == result.size()){
					result.add(val);
				}
			}
		}
		return result;
		
	}*/

	private int[] indexOf(String rule, String[] p) {
		int[] result = {0,0};
		int i = 0; 
		int min = rule.length();
		int len = 0;
		for(i = 0; i < p.length; i++){
			int val = rule.indexOf(p[i]);
			if(val >= 0 && val < min){
				min = val;
				len = p[i].length();
			}
		}
		if(min == rule.length())
			min = -1; 
		result[0] = min;
		result[1] = len;
		return result;
	}
}
