package org.once.serviceChoicer.qosDescrip2.token.impl;

import org.once.serviceChoicer.math.IPolynomial;
import org.once.serviceChoicer.math.impl.Polynomial;
import org.once.serviceChoicer.qosDescrip2.token.ILAttr;
import org.once.serviceChoicer.qosDescrip2.token.ILAttr4log;


public class LAttr4log4Pn implements ILAttr4log{

	private IPolynomial pn;
	
	public LAttr4log4Pn(IPolynomial pn){
		this.pn = pn;
	}
	
	public IPolynomial getLAttrValue() {
		return pn;
	}

	public void setLAttrValue(Object obj) {
		pn = (IPolynomial) obj;
	}
	
	public ILAttr opAND(ILAttr lAttrPn){
		pn.multi((IPolynomial) lAttrPn.getLAttrValue());
		return this;
	}

	@Override
	public ILAttr opNOT() {
		pn.multiCoef(-1);
		pn.add(new Polynomial(1));
		return this;
	}

	@Override
	public ILAttr opOR(ILAttr lAttr) {
		if(lAttr != null){
			if(pn== null){
				pn =  (IPolynomial) lAttr.getLAttrValue();
			}
			else{
				IPolynomial pn1 = pn.clone();
				IPolynomial pn2 = ((IPolynomial) lAttr.getLAttrValue()).clone();
				pn.multi(pn2);
				pn.multiCoef(-1);
				pn.add(pn1);
				pn.add(pn2);
			}
		}
		return this;
	}
	
	public String toString(){
		return this.pn.toString();
	}

/*	
	public ILAttr clone(){
		return this.clone1();
	}
	
	public LAttrPn clone1(){
		return this;
	}*/

}
